#include <iostream>
#include <fstream>
#include <sstream>
#include <map>
#include <vector>

#define ITEM 1682
#define USER 943

using namespace std;

typedef map< short, short > MAP_S;
typedef map< short, MAP_S > MAP_SS; // item, (user, rate)

float DEV_l[ITEM+1][ITEM+1][2]; // [0]:DEV(like) [1]:weight
float DEV_d[ITEM+1][ITEM+1][2]; // [0]:DEV(dislike) [1]:weight
float AVE[USER+1]; // average

// ****************
// baset@C
// ****************
MAP_SS input(char FILE_NO){
  MAP_SS OData;
  short user, item, rate;
  int date;

  stringstream ss;
  ss << "/home/shared/dataset/data" << FILE_NO << ".txt";
  ifstream fin( ss.str().c_str() );
  //ifstream fin( "./MovieLens/test.u.data" );
  if( !fin ){
    cout << "base file open error" << endl;
    exit(1);
  }

  while( fin >> user >> item >> rate >> date ){
    if(OData.find(item) == OData.end()){
      MAP_S user_rate;
      user_rate.insert( make_pair(user, rate) );
      OData.insert( make_pair( item, user_rate ));
    } else {
      OData[item].insert( make_pair(user, rate) );
    }
  }

  fin.close();

  return OData;
}

void user_ave(MAP_SS OData){
  int total, cnt;
  MAP_SS::iterator itr;

  for(int u=1; u<=USER; u++){
    total = 0; cnt = 0;
    for(itr = OData.begin(); itr != OData.end(); itr++){
      if( (*itr).second.find(u) != (*itr).second.end() ){
	total += (*itr).second[u]; cnt++;
      }
    }

    if(cnt != 0) AVE[u] = total*1.0/cnt;
    else AVE[u] = 0.0;
  }

  return;
}

// ********
// ϕ΍
// ********
void calc_dev(short i, short j, MAP_S im, MAP_S jm){
  int lr=0, ln=0, dr=0, dn=0;
  float ave;

  MAP_S::iterator itr_i, itr_j;

  for(itr_i = im.begin(), itr_j = jm.begin(); itr_i !=  im.end() && itr_j != jm.end(); ){
    if( (*itr_i).first == (*itr_j).first ){
      ave = AVE[(*itr_i).first];
      if( ave < (*itr_i).second && ave < (*itr_j).second ){
	lr += (*itr_i).second - (*itr_j).second;
	ln++;
      } else if ( (*itr_i).second < ave && (*itr_j).second < ave ){
	dr += (*itr_i).second - (*itr_j).second;
	dn++;
      }
      itr_i++; itr_j++;
    } else if( (*itr_i).first < (*itr_j).first ){
      itr_i++;
    } else {
      itr_j++;
    }
  }

  if(ln != 0){
    DEV_l[i][j][0] = lr*1.0/ln; DEV_l[i][j][1] = ln+1;
  } else {
    DEV_l[i][j][0] = 0.0; DEV_l[i][j][1] = 1;
  }
  DEV_l[j][i][0] = -DEV_l[i][j][0]; DEV_l[j][i][1] = DEV_l[i][j][1];
  if(dn != 0){
    DEV_d[i][j][0] = dr*1.0/dn; DEV_d[i][j][1] = dn+1;
  } else {
    DEV_d[i][j][0] = 0.0; DEV_d[i][j][1] = 1;
  }
  DEV_d[j][i][0] = -DEV_d[i][j][0]; DEV_d[j][i][1] = DEV_d[i][j][1];

  return;
}

void make_dev(MAP_SS OData){
  MAP_SS::iterator itr_i, itr_j;
  int cnt = 0;
 
  for(short i=1; i<=ITEM; i++){
    for(short j=i+1; j<=ITEM; j++){
      /* mFp */
      cnt++; if(cnt%10000 == 0) cout << cnt/10000 << "/141" << endl;

      itr_i = OData.find(i);
      itr_j = OData.find(j);
      if( itr_i != OData.end() && itr_j != OData.end() ){
	calc_dev( i, j, (*itr_i).second, (*itr_j).second );
      }
    }
  }

  return;
}

vector< pair<short, short> > user_eval(short u, MAP_SS OData){
  vector< pair<short, short> > v;
  MAP_SS::iterator itr;

  for(itr = OData.begin(); itr != OData.end(); itr++){
    if( (*itr).second.find(u) != (*itr).second.end() )
      v.push_back( make_pair((*itr).first,(*itr).second[u]) );
  }

  return v;
}

float recommend(short u, short i, MAP_SS OData){
  MAP_SS::iterator itr;
  vector< pair<short, short> > v;
  vector< pair<short, short> >::iterator it;

  v = user_eval(u, OData);

  float total = 0.0, w_total = 0;

  for(it = v.begin(); it != v.end(); it++){
    if( AVE[u] < (*it).second ){
      total += ( (*it).second + DEV_l[i][(*it).first][0] ) * DEV_l[i][(*it).first][1];
      w_total += DEV_l[i][(*it).first][1];
    } else if( (*it).second < AVE[u] ){
      total += ( (*it).second + DEV_d[i][(*it).first][0] ) * DEV_d[i][(*it).first][1];
      w_total += DEV_d[i][(*it).first][1];
    }
  }

  if(w_total != 0){
    return total/w_total;
  } else {
    return 0.0;
  }
}

// ******
// C
// ******
int main(char argc, char *argv[]){
  MAP_SS OData = input( *argv[1] );

  // fobOp
  //MAP_S::iterator itr_i;
  //cout << "OData" << endl;
  //itr_i = OData.begin();
  //while( itr_i != OData.end() ){
  //  cout << "(" << (*itr_i).first.first << " , " <<  (*itr_i).first.second << ")" << (*itr_i).second << endl;
  //  itr_i++;
  //}
  cout << "f[^͊" << endl;

  user_ave(OData);
  /* fobOp
  for(int u=1; u<=USER; u++){
    cout << AVE[u] << " ";
  }
  */
  cout << "[U[]ϊ" << endl;

  make_dev(OData);

  cout << "DEV쐬" << endl; 
  /* fobOp
  for(short i=1; i<=ITEM; i++){
    for(short j=1; j<=ITEM; j++){
      if(i==j) cout << "0" << "\t";
      else cout << DEV_l[i][j][0] << "," << DEV_l[i][j][1] << "\t";
    }
    cout << endl;
  }
  cout << endl;
  for(short i=1; i<=ITEM; i++){
    for(short j=1; j<=ITEM; j++){
      if(i==j) cout << "0" << "\t";
      else cout << DEV_d[i][j][0] << "," << DEV_d[i][j][1] << "\t";
    }
    cout << endl;
  }
  */

  short user, item, rate;
  int date;

  /* testt@C */
  stringstream ss_t;
  ss_t << "/home/shared/dataset/test" << *argv[1] << ".txt";
  ifstream fin( ss_t.str().c_str() );
  //ifstream fin( "./MovieLens/test.u.test" );
  if( !fin ){
    cout << "test file open error" << endl;
    return 1;
  }

  /* t@Co */
  stringstream ss_o;
  ss_o << "data" << *argv[1] << ".out.bs";
  ofstream fout( ss_o.str().c_str() );
  //ofstream fout( "test.u.out.bs" );
  int fn = 0;
  while( fin >> user >> item >> rate >> date ){
    fn++; if(fn%100 == 0) cout << fn << "/20000" << endl; /* mFp */
    fout << user << "\t" << item << "\t" << recommend(user, item, OData) << endl;
  }

  OData.clear();
  fin.close();
  fout.close();

  return 0;
}
